import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.Line2D;
import java.util.Vector;

public class DrawPanel extends JPanel implements MouseListener, MouseMotionListener{
    
    private Vector drawnGeom;
    
    public DrawPanel() {
        super();
        
        addMouseListener(this);
        addMouseMotionListener(this);
        
        drawnGeom = new Vector();
    }
    // ------ MouseListener --------------------------    
    public void mousePressed(MouseEvent e){
        setFirstLinePoint(e.getPoint());       
    }
      
    public void mouseClicked(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    
    // ------ MouseMotionListener --------------------
    public void mouseDragged(MouseEvent e) {
        setSecondLinePoint(e.getPoint());
    }
    
    public void mouseMoved(MouseEvent e) {}
    // -----------------------------------------------
    
    private void setFirstLinePoint(Point p) {
        drawnGeom.addElement(new Line2D.Double(p, p));
        this.repaint();
    }
    
    private void setSecondLinePoint(Point p) {
       ((Line2D.Double) drawnGeom.lastElement()).setLine(
              ((Line2D.Double) drawnGeom.lastElement()).getP1(), p);
        this.repaint();
    }
    
    private int getRandom(){
        return (int)(Math.random()*256);
    }
        
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        int i=0;
        while(i < drawnGeom.size()){
            Line2D.Double line = (Line2D.Double) drawnGeom.elementAt(i);
            i=i+1;
            g.setColor(new Color(getRandom(), getRandom(), getRandom()));
            g.drawLine((int)line.x1, (int)line.y1, (int)line.x2, (int)line.y2);           
        }
    }
}







